#ifndef CoCoA_DenseMatrix_H
#define CoCoA_DenseMatrix_H

//   Copyright (c)  2005-2009  John Abbott

//   This file is part of the source of CoCoALib, the CoCoA Library.

//   CoCoALib is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.

//   CoCoALib is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.

//   You should have received a copy of the GNU General Public License
//   along with CoCoALib.  If not, see <http://www.gnu.org/licenses/>.


#include <vector>
//using std::vector;


namespace CoCoA
{

  class ConstMatrixView;  // forward declaration -- defined in matrix.H
  class ConstRefRingElem; // forward declaration -- defined in ring.H
  class matrix;           // forward declaration -- defined in matrix.H
  class ring;             // forward declaration -- defined in ring.H

  matrix NewDenseMat(const ring& R, long NumRows, long NumCols);
  matrix NewDenseMat(const ring& R, long NumRows, long NumCols, const std::vector< std::vector<long> >& M);
  matrix NewDenseMat(ConstMatrixView M);

} // end of namespace CoCoA


// RCS header/log in the next few lines
// $Header: /Volumes/Home_1/cocoa/cvs-repository/CoCoALib-0.99/include/CoCoA/DenseMatrix.H,v 1.8 2011/03/21 13:19:35 bigatti Exp $
// $Log: DenseMatrix.H,v $
// Revision 1.8  2011/03/21 13:19:35  bigatti
// -- removed useless fwd declaration
//
// Revision 1.7  2011/03/08 17:54:54  bigatti
// -- changed: args for rows and cols are now  long  instead of  MachineInteger
//
// Revision 1.6  2011/03/04 16:16:53  bigatti
// -- changed: args of type MachineInteger instead of size_t
//
// Revision 1.5  2009/09/24 13:39:12  abbott
// Removed unnecessary forward declaration.
// Added missing logging keyword.
//
//

#endif
